#include <hildon-cp-plugin/hildon-cp-plugin-interface.h>

#include <hildon-cp-plugin/hildon-cp-plugin-interface.h>
#include <gtk/gtk.h>
#include <dirent.h>
#include <stdio.h>
#include <stdlib.h>

// function getProcessID(char*) used to find process id
// taken from http://www.linuxforums.org/forum/programming-scripting/40078-c-printing-linux-process-table.html
unsigned int getProcessID(char *p_processname)
{
	DIR *dir_p;
	struct dirent *dir_entry_p;
	char dir_name[40];				// ??? buffer overrun potential
	char target_name[252];				// ??? buffer overrun potential
	int target_result;
	char exe_link[252];
	int errorcount;
	int result;

	errorcount=0;
	result=0;
	dir_p = opendir("/proc/"); 			// Open /proc/ directory
	while(NULL != (dir_entry_p = readdir(dir_p)))
	{						// Reading /proc/ entries
		if (strspn(dir_entry_p->d_name, "0123456789") == strlen(dir_entry_p->d_name)) 
		{					// Checking for numbered directories 
			strcpy(dir_name, "/proc/");
			strcat(dir_name, dir_entry_p->d_name);
			strcat(dir_name, "/"); 		// Obtaining the full-path eg: /proc/24657/ 
			exe_link[0] = 0;
			strcat(exe_link, dir_name);
			strcat(exe_link, "exe");	// Getting the full-path of that exe link
			target_result = readlink(exe_link, target_name, sizeof(target_name)-1);
							// Getting the target of the exe ie to which binary it points to
			if (target_result > 0) 
			{
				target_name[target_result] = 0;
				if (strstr(target_name, p_processname) != NULL) 
				{	// Searching for process name in the target name -- ??? could be a better search !!!
					result = atoi(dir_entry_p->d_name);
					printf("getProcessID(&#37;s) :Found. id = %d\n", p_processname, result);
					closedir(dir_p);
					return result;
				}
			}
		}
	}
	closedir(dir_p);
	printf("getProcessID(%s) : id = 0 (could not find process)\n", p_processname);
	return result;
}

 
osso_return_t execute(osso_context_t *osso, gpointer data, gboolean user_activated)
{
	GtkWidget *dialog;
	GtkWidget *label;
	GtkWidget *box;
	gint response;
	unsigned int result;
	/* Create dialog with OK and Cancel buttons. Leave the separator out,
	 * as we do not have any content. */
	dialog = gtk_dialog_new_with_buttons(
		"mmmRemotePhoneControl config",
		GTK_WINDOW(data),
		GTK_DIALOG_MODAL,
		GTK_STOCK_OK,
		GTK_RESPONSE_OK,
		GTK_STOCK_CANCEL,
		GTK_RESPONSE_CANCEL,
		NULL);
	/* ... add something to the dialog ... */
	result = getProcessID("/opt/mmmrpcserver/final-server.py");
	if(result>0)
		label = gtk_label_new("Server is running now");
	else
		label = gtk_label_new("Server is not running now");
	box = gtk_dialog_get_content_area(GTK_DIALOG(dialog));
	gtk_box_pack_start(GTK_BOX(box), label, TRUE, TRUE, 0);
	if (!user_activated)
	{
		/* ... load state ... */
	}
	gtk_widget_show_all(dialog);
	/* Wait until user finishes the dialog. */
	response = gtk_dialog_run(GTK_DIALOG(dialog));
	if (response == GTK_RESPONSE_OK)
	{
		/* ... do something with the dialog stuff ... */
	}
	/* Free the dialog (and it's children) */
	gtk_widget_destroy(GTK_WIDGET(dialog));
	return OSSO_OK;
}

osso_return_t save_state(osso_context_t *osso, gpointer data)
{
	/* ... save state ... */
	return OSSO_OK;
}


